<?php
/*                                                                                                                                                       
  mememe                                     ememem
    \ememememem                       ememememem/ 
     ememememememem               ememememememem  
      emememememememe           emememememememe   
         \memememememem       ememememememe/      
         emememememememe     emememememememe     
                 emememem   ememememe              
                     ememe ememe                   
                       emememe                     
                         eme
                          e     
							           
	^^ Title : Canonical url for multishop						 
	^^ Create : 2021-10-29
	^^ Copyright : EAGLEMEDIA.de  
*/
	# Reports for either E_ERROR | E_WARNING | 
	# E_NOTICE | Any Error
	#
	#ini_set("display_startup_errors", 1);
	#ini_set("display_errors", 1);
	#error_reporting(E_ALL);

if (!defined('_PS_VERSION_'))
	exit;

class Canonical4Multishop extends Module
{
	
    public function __construct()
	{
		$this->name = 'canonical4multishop';
        $this->tab = 'seo';
		$this->version = '1.6.0';
		$this->author = 'EAGLEMEDIA.de';
		$this->need_instance = 0;

		$this->bootstrap = true;
		parent::__construct();	
		
		$this->displayName = $this->l('Canonical url for multishop');
		$this->description = $this->l('Adds a link tag with canonical attribute in header of the page. Only for Multishop -versions');
		$this->ps_versions_compliancy = array('min' => '1.6.0.0', 'max' => '1.7.99.99');
		$this->confirmUninstall = $this->l('Are you sure you want to uninstall this module?');
	}
	
    public function install()
	{
		$this->_clearCache('views/hook/front/canonical4multishop.tpl');
		if (!parent::install()		
	    OR  !$this->registerHook('header')
		OR  !Configuration::updateValue('CANONICAL_TAIL_MULTISHOP', 'com') )
			return false;
		return true;
	}

    public function uninstall()	
	{	
		$this->_clearCache('views/hook/front/canonical4multishop.tpl');	    
		if (!parent::uninstall()
		OR  !$this->unregisterHook('header')	
		OR  !Configuration::deleteByName('CANONICAL_TAIL_MULTISHOP'))
			return false;
		return true;
	}
	


	private function postProcess()
	{		
		if( Tools::isSubmit('submitCanonical') )
		{			
			if( strlen(Tools::getValue('CANONICAL_TAIL_MULTISHOP')) >= 2 
            AND !is_numeric(Tools::getValue('CANONICAL_TAIL_MULTISHOP')) )
			{
			    Configuration::updateValue('CANONICAL_TAIL_MULTISHOP', Tools::getValue('CANONICAL_TAIL_MULTISHOP'));				
			    $this->_clearCache('views/hook/front/canonical4multishop.tpl');
                
				return $this->displayConfirmation($this->l('The settings have been updated !'));
			}
            
            return $this->displayError($this->l('You must correcting domain ending !'));
		}
        
        		
	}
			
	public function getContent()
	{
		return $this->postProcess().$this->renderForm();
	}

    public function renderForm()
	{
	    $fields_form_1 = '
            <div class="loginpageslide text-center">
                '.$this->l('Have a look at my modules for PrestaShop').' -
                <a href="https://eaglemedia.de/cms.php?s=prestashop-module" target="_blank"><b>MODULE</b></a>
                <p class="clear"> </p>
                '.$this->l('Made with').' <i class="icon-heart"></i> '.$this->l('by').'
                <a href="http://eaglemedia.de" target="_blank"><b>EAGLEMEDIA</b></a>
                <p class="clear"><br/> </p>

                <form action="https://www.paypal.com/donate" method="post" target="_blank">
                    <input type="hidden" name="hosted_button_id" value="ALLRFT5RZJVHN" />
                    <input type="image" src="https://www.paypalobjects.com/de_DE/DE/i/btn/btn_donateCC_LG.gif" 
                           border="0" name="submit" title="PayPal - The safer, easier way to pay online!" alt="Donate with PayPal button" />

                    <img alt="" border="0" src="https://www.paypal.com/de_DE/i/scr/pixel.gif" width="1" height="1" />
                </form>
                <p class="clear"><br/><br/> </p>	
            </div>';
        
		$fields_form_2 = array(
			'form' => array(			    
				'legend' => array(
					'title' => $this->l('Settings'),
					'icon' => 'icon-cogs'
				), 
				'input' => array(                    
					array(
						'type' => 'text',
						'label' => $this->l('Canonical domain ending'),
						'name' => 'CANONICAL_TAIL_MULTISHOP',
						'desc' => $this->l('Set the domain ending without dot of the default domain here.')			
                    )
				),					
				'submit' => array(
					'title' => $this->l('Save')
				)
			)
		);

		$helper = new HelperForm();
		$helper->show_toolbar = false;
		$helper->table =  $this->table;
		$lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
		$helper->default_form_language = $lang->id;
		$helper->module = $this;
		$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;		
		$helper->identifier = $this->identifier;
		$helper->submit_action = 'submitCanonical';
		$helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
		$helper->token = Tools::getAdminTokenLite('AdminModules');
		$helper->tpl_vars = array(
			'uri' => $this->getPathUri(),
			'fields_value' => $this->getConfigFieldsValues(),
			'languages' => $this->context->controller->getLanguages(),
			'id_language' => $this->context->language->id
		);

		return $fields_form_1.$helper->generateForm(array($fields_form_2));
	}
	
    public function getConfigFieldsValues()
    {
        return array(
            'CANONICAL_TAIL_MULTISHOP' => Tools::getValue('CANONICAL_TAIL_MULTISHOP', Configuration::get('CANONICAL_TAIL_MULTISHOP'))        
        );
    }			

    #
	#
	#

	public function hookHeader($params)
	{   
          
        $shop_dir_base_arr = explode('/', Tools::getHttpHost(true).__PS_BASE_URI__);
        $shop_dir_base = $shop_dir_base_arr[0].'//'.$shop_dir_base_arr[2].'/'; 
        $shop_dir_base_split = explode('.', $shop_dir_base);
        if (count($shop_dir_base_split) > 2)      
            $shop_dir_base_ = $shop_dir_base_split[0].'.'.$shop_dir_base_split[1];           
        else 
            $shop_dir_base_ = $shop_dir_base_split[0];
        $shop_url = $this->context->link->getLanguageLink($lang->id); 

        $canonical_tail = Configuration::get('CANONICAL_TAIL_MULTISHOP');            
        $canonical_base_dir = $shop_dir_base_.'.'.$canonical_tail.'/';
        $canonical_url = str_replace($shop_dir_base, $canonical_base_dir, $shop_url); 

        $this->smarty->assign(
            array(				
                'canonical_url' => $canonical_url,
            )
        );	
        
		return $this->display(__FILE__, 'views/hook/front/canonical4multishop.tpl');
	}
	
}	
